const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const price_list_lines = sequelize.define(
    'price_list_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

unit_price: {
        type: DataTypes.DECIMAL,
      
      

      },

min_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

effective_from: {
        type: DataTypes.DATE,
      
      

      },

effective_to: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  price_list_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.price_list_lines.belongsTo(db.price_lists, {
      as: 'price_list',
      foreignKey: {
        name: 'price_listId',
      },
      constraints: false,
    });

    db.price_list_lines.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });




    db.price_list_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.price_list_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return price_list_lines;
};


